#!/usr/bin/python
#coding=utf-8
import threading,traceback,time,importlib,imp,os,logging,json,io
from imp import reload
from concurrent.futures import ThreadPoolExecutor
import sys
if sys.version_info.major == 2:
  from core.utils import printInfo
  from downloader import execDownload
  from extracter import Extracter
  reload(sys)
  sys.setdefaultencoding('utf-8')
else:
  from .core.utils import printInfo
  from .downloader import execDownload
  from .extracter import Extracter
try:
  from setting import SETTINGFILE
except ImportError:
  SETTINGFILE = 'setting.json'
class SimplifiedMain():
  def __init__(self,ssp=None):
    try:
      self._settingObj = {}
      self.singleSSP = ssp
      if(ssp):
        logging.basicConfig(
          level=logging.DEBUG,#控制台打印的日志级别
          filename='spider.log',
          filemode='a',##模式，有w和a，w就是写模式，每次都会重新写日志，覆盖之前的日志。a是追加模式，默认如果不写的话，就是追加模式
          format='%(asctime)s - %(pathname)s[line:%(lineno)d] - %(levelname)s: %(message)s')
      self.refrashSSP()
      self._extracter = Extracter()
      self._pool = ThreadPoolExecutor(max_workers=self._settingObj["max_workers"])
    except Exception as err:
      self.log(err,logging.ERROR)
  def refrashSSP(self):
    try:
      if(os.path.exists(SETTINGFILE)):
        settingJson = io.open(SETTINGFILE, "r",encoding="utf-8").read()
        settingObj = json.loads(settingJson)
        dicTmp = []
        if(not self.singleSSP and settingObj.get('spiders')):
          for spider in settingObj['spiders']:
            try:
              dicTmp.append(spider['file'])
              self.getSpider(spider['file'],spider["class"])
            except Exception as err:
              self.log(err,logging.ERROR)

          keys = self._spiderDic.keys()
          for key in keys:
            if(key not in dicTmp):
              del self._spiderDic[key]
      else:
        settingObj = {}
      if(self.singleSSP): self._spiderDic[self.singleSSP.name] = self.singleSSP

      if(not settingObj.get("concurrency")):
        settingObj["concurrency"] = 5
      if(not settingObj.get("concurrencyPer1S")):
        settingObj["concurrencyPer1S"] = 10
      if(not settingObj.get("intervalTime")):
        settingObj["intervalTime"] = 0.3
      if(not settingObj.get("max_workers")):
        settingObj["max_workers"] = 10
      
      self._settingObj = settingObj
    except Exception as err:
      self.log(err,logging.ERROR)
    
  def log(self, msg, level=logging.DEBUG):
    if (isinstance(msg,UnicodeEncodeError)):
      printInfo('UnicodeEncodeError', msg)
      return
    printInfo(msg)
    if(level==logging.ERROR):
      logger = logging.getLogger()
      logging.LoggerAdapter(logger, None).log(level, msg)

  _runflag = False
  def setRunFlag(self, flag):
    self._runflag = flag

  _spiderDic = {}
  def startThread(self):
    threadExtract = threading.Thread(target=self.extractThread)
    threadExtract.start()
    startTime = time.time()
    while self._runflag:
      if((time.time()-startTime) > 30):
        startTime = time.time()
        self.refrashSSP()
      try:
        if(os.path.exists('stop.txt')):
          self._runflag = False
          os.rename('stop.txt','stoped.txt')
          break
        urlFlag = False
        for ssp in self._spiderDic.values():
          if(not ssp): continue
          urlCount = ssp.urlCount()
          if(self.checkConcurrency(ssp.name,urlCount)):
            url = ssp.popUrl()
            if(url):
              urlFlag = True
              self._pool.submit(self.downloadThread2,url,ssp)
              # thread = threading.Thread(target=self.downloadThread, args=(url,ssp))
              # thread.start()
            else:
              self._concurrency-=1
          if(urlCount==0):
            plan = ssp.plan()
            ssp.resetUrls(plan)
        if(not urlFlag):
          time.sleep(3)
      except Exception as err:
        self.log(err,logging.ERROR)
        time.sleep(10)
      time.sleep(self._settingObj["intervalTime"])
    self._runflag=False
    self._pool.shutdown()
    self.log('download app stoped......')

  _concurrency=0
  _downloadPageNum=0
  _startCountTs=time.time()
  def checkConcurrency(self,name,count):
    tmSpan = time.time()-self._startCountTs
    if(tmSpan>10):
      if(self._downloadPageNum>(self._settingObj["concurrencyPer1S"]*tmSpan)):
        self.log('name={}, count={}, concurrency={}, downloadPageNum={}, tmSpan={}, reason={}'.format(name,count,self._concurrency,self._downloadPageNum,tmSpan,'exceed the config number CONCURRENCYPER1S'))
        return False
      self._startCountTs=time.time()
      self._downloadPageNum=0
    if self._concurrency >= self._settingObj["concurrency"]:
      self.log('name={}, count={}, concurrency={}, downloadPageNum={}, tmSpan={}, reason={}'.format(name,count,self._concurrency,self._downloadPageNum,tmSpan,'exceed the config number CONCURRENCY'))
      return False
    self._concurrency+=1
    self.log('name={}, count={}, concurrency={}, downloadPageNum={}, tmSpan={}'.format(name,count,self._concurrency,self._downloadPageNum,tmSpan))
    return True

  def getSpider(self, fileName, className):
    try:
      m = importlib.import_module(fileName)
      if(fileName in self._spiderDic):
        reload(m)
        cls = getattr(m, className)
        ssp = cls()
        if(ssp.version == self._spiderDic[fileName].version):
          return self._spiderDic[fileName]
      else:
        cls = getattr(m, className)
        ssp = cls()

      flag = False
      i = 3
      while(i>0):
        flag = ssp.login()
        if(flag): break
        i=i-1
      if(flag):
        self._spiderDic[fileName]=ssp
      else:
        printInfo(className +': login failed')
      return ssp
    except Exception as err:
      self.log(err,logging.ERROR)

  def extractThread(self):
    while(self._runflag):
      flag=False
      for ssp in self._spiderDic.values():
        try:
          data = ssp.popHtml()
          if(not data):
            data = ssp.popHtml(2)

          if(data):
            flag = True
            obj = self._extracter.extract(data["url"],data["html"],ssp)
            if obj: 
              ssp.saveData(obj)
              ssp.updateHtmlState(data["id"],1)
            else:
              ssp.updateHtmlState(data["id"],2)
            if(ssp.models and len(ssp.models)>0):
              time.sleep(0.5)
            else:
              time.sleep(0.01)

        except Exception as err:
          self.log(err,logging.ERROR)
          time.sleep(10)
      if(not flag):
        time.sleep(3)
      time.sleep(1)
  def downloadThread(self,url,ssp):
    try:
      if(not url):
        return
      if(isinstance(url,str)):
        url={'url':url}
      printInfo(url['url'])
      self._downloadPageNum=self._downloadPageNum+1
      html = execDownload(url,ssp)
      if(html=="_error_"):
        # self._extracter.extract(url,html,ssp)
        # else:
        ssp.downloadError(url)
      else:
        ssp.saveHtml(url,html)
    except Exception as err:
      self.log(err,logging.ERROR)
    finally:
      self._concurrency-=1
  def downloadThread2(self,*args):
    url=args[0]
    ssp=args[1]
    try:
      if(not url):
        return
      if(isinstance(url,str)):
        url={'url':url}
      printInfo(url['url'])
      self._downloadPageNum=self._downloadPageNum+1
      html = execDownload(url,ssp)
      if(html=="_error_"):
        ssp.downloadError(url)
      else:
        ssp.saveHtml(url,html)
    except Exception as err:
      self.log(err,logging.ERROR)
    finally:
      self._concurrency-=1